/*
 * This file is part of the Score-P software (http://www.score-p.org)
 *
 * Copyright (c) 2009-2012,
 * RWTH Aachen University, Germany
 *
 * Copyright (c) 2009-2012,
 * Gesellschaft fuer numerische Simulation mbH Braunschweig, Germany
 *
 * Copyright (c) 2009-2012, 2016, 2024,
 * Technische Universitaet Dresden, Germany
 *
 * Copyright (c) 2009-2012,
 * University of Oregon, Eugene, USA
 *
 * Copyright (c) 2009-2012, 2014, 2025,
 * Forschungszentrum Juelich GmbH, Germany
 *
 * Copyright (c) 2009-2012,
 * German Research School for Simulation Sciences GmbH, Juelich/Aachen, Germany
 *
 * Copyright (c) 2009-2012,
 * Technische Universitaet Muenchen, Germany
 *
 * This software may be modified and distributed under the terms of
 * a BSD-style license. See the COPYING file in the package base
 * directory for details.
 *
 */

/*
 * This file was generated by mpi_wrapgen2 from template adapter/c/scorep_mpi_groups.c.tmpl.
 */

#include <config.h>

#include <scorep_mpi_groups.h>

void
scorep_mpi_enable_derived_groups( void )
{
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_CG ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_ERR ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_CG_ERR;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_CG ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_EXT ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_CG_EXT;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_CG ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_MISC ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_CG_MISC;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_IO ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_ERR ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_IO_ERR;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_IO ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_MISC ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_IO_MISC;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_RMA ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_ERR ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_RMA_ERR;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_RMA ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_EXT ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_RMA_EXT;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_RMA ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_MISC ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_RMA_MISC;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_TYPE ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_EXT ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_TYPE_EXT;
    }
    if ( ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_TYPE ) && ( scorep_mpi_enabled & SCOREP_MPI_ENABLED_MISC ) )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_TYPE_MISC;
    }

    /* Enable REQUEST group if any of its depending groups is enabled */
    uint64_t enable_request_mask = SCOREP_MPI_ENABLED_CG   |
                                   SCOREP_MPI_ENABLED_COLL |
                                   SCOREP_MPI_ENABLED_EXT  |
                                   SCOREP_MPI_ENABLED_IO   |
                                   SCOREP_MPI_ENABLED_P2P  |
                                   SCOREP_MPI_ENABLED_RMA;
    if ( scorep_mpi_enabled & enable_request_mask )
    {
        scorep_mpi_enabled |= SCOREP_MPI_ENABLED_REQUEST;
    }
}
