!
! This file is part of the Score-P software (http://www.score-p.org)
!
! Copyright (c) 2025,
! Forschungszentrum Juelich GmbH, Germany
!
! This software may be modified and distributed under the terms of
! a BSD-style license. See the COPYING file in the package base
! directory for details.
!

!
! This file was generated by mpi_wrapgen2 from template adapter/f08/SCOREP_Mpi_Reg_H.f90.tmpl.
!

!>
!> @file
!> @ingroup    MPI_Wrapper
!>
!> @brief Registration of MPI regions
!>

module SCOREP_Mpi_Reg_H
    use :: SCOREP_PublicTypes_H, only:SCOREP_RegionHandle

    implicit none

    private :: SCOREP_RegionHandle

    ! The parameter values have to be the same as the corresponding values
    ! in the scorep_mpi_regions enum in SCOREP_Mpi_Reg.h.
    integer, parameter :: SCOREP_MPI_REGION__MPI_ABORT = 1
    integer, parameter :: SCOREP_MPI_REGION__MPI_ACCUMULATE = 2
    integer, parameter :: SCOREP_MPI_REGION__MPI_ADD_ERROR_CLASS = 3
    integer, parameter :: SCOREP_MPI_REGION__MPI_ADD_ERROR_CODE = 4
    integer, parameter :: SCOREP_MPI_REGION__MPI_ADD_ERROR_STRING = 5
    integer, parameter :: SCOREP_MPI_REGION__MPI_ADDRESS = 6
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLGATHER = 7
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLGATHER_INIT = 8
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLGATHERV = 9
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLGATHERV_INIT = 10
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLOC_MEM = 11
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLREDUCE = 12
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLREDUCE_INIT = 13
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALL = 14
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALL_INIT = 15
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALLV = 16
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALLV_INIT = 17
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALLW = 18
    integer, parameter :: SCOREP_MPI_REGION__MPI_ALLTOALLW_INIT = 19
    integer, parameter :: SCOREP_MPI_REGION__MPI_ATTR_DELETE = 20
    integer, parameter :: SCOREP_MPI_REGION__MPI_ATTR_GET = 21
    integer, parameter :: SCOREP_MPI_REGION__MPI_ATTR_PUT = 22
    integer, parameter :: SCOREP_MPI_REGION__MPI_BARRIER = 23
    integer, parameter :: SCOREP_MPI_REGION__MPI_BARRIER_INIT = 24
    integer, parameter :: SCOREP_MPI_REGION__MPI_BCAST = 25
    integer, parameter :: SCOREP_MPI_REGION__MPI_BCAST_INIT = 26
    integer, parameter :: SCOREP_MPI_REGION__MPI_BSEND = 27
    integer, parameter :: SCOREP_MPI_REGION__MPI_BSEND_INIT = 28
    integer, parameter :: SCOREP_MPI_REGION__MPI_BUFFER_ATTACH = 29
    integer, parameter :: SCOREP_MPI_REGION__MPI_BUFFER_DETACH = 30
    integer, parameter :: SCOREP_MPI_REGION__MPI_CANCEL = 31
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_COORDS = 32
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_CREATE = 33
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_GET = 34
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_MAP = 35
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_RANK = 36
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_SHIFT = 37
    integer, parameter :: SCOREP_MPI_REGION__MPI_CART_SUB = 38
    integer, parameter :: SCOREP_MPI_REGION__MPI_CARTDIM_GET = 39
    integer, parameter :: SCOREP_MPI_REGION__MPI_CLOSE_PORT = 40
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_ACCEPT = 41
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_C2F = 42
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CALL_ERRHANDLER = 43
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_COMPARE = 44
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CONNECT = 45
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CREATE = 46
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CREATE_ERRHANDLER = 47
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CREATE_FROM_GROUP = 48
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CREATE_GROUP = 49
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_CREATE_KEYVAL = 50
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_DELETE_ATTR = 51
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_DISCONNECT = 52
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_DUP = 53
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_DUP_WITH_INFO = 54
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_F2C = 55
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_FREE = 56
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_FREE_KEYVAL = 57
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GET_ATTR = 58
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GET_ERRHANDLER = 59
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GET_INFO = 60
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GET_NAME = 61
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GET_PARENT = 62
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_GROUP = 63
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_IDUP = 64
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_IDUP_WITH_INFO = 65
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_JOIN = 66
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_RANK = 67
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_REMOTE_GROUP = 68
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_REMOTE_SIZE = 69
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SET_ATTR = 70
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SET_ERRHANDLER = 71
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SET_INFO = 72
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SET_NAME = 73
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SIZE = 74
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SPAWN = 75
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SPAWN_MULTIPLE = 76
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SPLIT = 77
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_SPLIT_TYPE = 78
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMM_TEST_INTER = 79
    integer, parameter :: SCOREP_MPI_REGION__MPI_COMPARE_AND_SWAP = 80
    integer, parameter :: SCOREP_MPI_REGION__MPI_DIMS_CREATE = 81
    integer, parameter :: SCOREP_MPI_REGION__MPI_DIST_GRAPH_CREATE = 82
    integer, parameter :: SCOREP_MPI_REGION__MPI_DIST_GRAPH_CREATE_ADJACENT = 83
    integer, parameter :: SCOREP_MPI_REGION__MPI_DIST_GRAPH_NEIGHBORS = 84
    integer, parameter :: SCOREP_MPI_REGION__MPI_DIST_GRAPH_NEIGHBORS_COUNT = 85
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_C2F = 86
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_CREATE = 87
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_F2C = 88
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_FREE = 89
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_GET = 90
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERRHANDLER_SET = 91
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERROR_CLASS = 92
    integer, parameter :: SCOREP_MPI_REGION__MPI_ERROR_STRING = 93
    integer, parameter :: SCOREP_MPI_REGION__MPI_EXSCAN = 94
    integer, parameter :: SCOREP_MPI_REGION__MPI_EXSCAN_INIT = 95
    integer, parameter :: SCOREP_MPI_REGION__MPI_FETCH_AND_OP = 96
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_C2F = 97
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_CALL_ERRHANDLER = 98
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_CLOSE = 99
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_CREATE_ERRHANDLER = 100
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_DELETE = 101
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_F2C = 102
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_AMODE = 103
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_ATOMICITY = 104
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_BYTE_OFFSET = 105
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_ERRHANDLER = 106
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_GROUP = 107
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_INFO = 108
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_POSITION = 109
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_POSITION_SHARED = 110
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_SIZE = 111
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_TYPE_EXTENT = 112
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_GET_VIEW = 113
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IREAD = 114
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IREAD_ALL = 115
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IREAD_AT = 116
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IREAD_AT_ALL = 117
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IREAD_SHARED = 118
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IWRITE = 119
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IWRITE_ALL = 120
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IWRITE_AT = 121
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IWRITE_AT_ALL = 122
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_IWRITE_SHARED = 123
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_OPEN = 124
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_PREALLOCATE = 125
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ = 126
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ALL = 127
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ALL_BEGIN = 128
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ALL_END = 129
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_AT = 130
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL = 131
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL_BEGIN = 132
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL_END = 133
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED = 134
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED_BEGIN = 135
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED_END = 136
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_READ_SHARED = 137
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SEEK = 138
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SEEK_SHARED = 139
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SET_ATOMICITY = 140
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SET_ERRHANDLER = 141
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SET_INFO = 142
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SET_SIZE = 143
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SET_VIEW = 144
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_SYNC = 145
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE = 146
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL = 147
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL_BEGIN = 148
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL_END = 149
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_AT = 150
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL = 151
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL_BEGIN = 152
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL_END = 153
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED = 154
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED_BEGIN = 155
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED_END = 156
    integer, parameter :: SCOREP_MPI_REGION__MPI_FILE_WRITE_SHARED = 157
    integer, parameter :: SCOREP_MPI_REGION__MPI_FINALIZE = 158
    integer, parameter :: SCOREP_MPI_REGION__MPI_FINALIZED = 159
    integer, parameter :: SCOREP_MPI_REGION__MPI_FREE_MEM = 160
    integer, parameter :: SCOREP_MPI_REGION__MPI_GATHER = 161
    integer, parameter :: SCOREP_MPI_REGION__MPI_GATHER_INIT = 162
    integer, parameter :: SCOREP_MPI_REGION__MPI_GATHERV = 163
    integer, parameter :: SCOREP_MPI_REGION__MPI_GATHERV_INIT = 164
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET = 165
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_ACCUMULATE = 166
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_ADDRESS = 167
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_COUNT = 168
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_ELEMENTS = 169
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_ELEMENTS_X = 170
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_LIBRARY_VERSION = 171
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_PROCESSOR_NAME = 172
    integer, parameter :: SCOREP_MPI_REGION__MPI_GET_VERSION = 173
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPH_CREATE = 174
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPH_GET = 175
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPH_MAP = 176
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPH_NEIGHBORS = 177
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPH_NEIGHBORS_COUNT = 178
    integer, parameter :: SCOREP_MPI_REGION__MPI_GRAPHDIMS_GET = 179
    integer, parameter :: SCOREP_MPI_REGION__MPI_GREQUEST_COMPLETE = 180
    integer, parameter :: SCOREP_MPI_REGION__MPI_GREQUEST_START = 181
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_C2F = 182
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_COMPARE = 183
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_DIFFERENCE = 184
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_EXCL = 185
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_F2C = 186
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_FREE = 187
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_FROM_SESSION_PSET = 188
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_INCL = 189
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_INTERSECTION = 190
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_RANGE_EXCL = 191
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_RANGE_INCL = 192
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_RANK = 193
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_SIZE = 194
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_TRANSLATE_RANKS = 195
    integer, parameter :: SCOREP_MPI_REGION__MPI_GROUP_UNION = 196
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLGATHER = 197
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLGATHERV = 198
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLREDUCE = 199
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLTOALL = 200
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLTOALLV = 201
    integer, parameter :: SCOREP_MPI_REGION__MPI_IALLTOALLW = 202
    integer, parameter :: SCOREP_MPI_REGION__MPI_IBARRIER = 203
    integer, parameter :: SCOREP_MPI_REGION__MPI_IBCAST = 204
    integer, parameter :: SCOREP_MPI_REGION__MPI_IBSEND = 205
    integer, parameter :: SCOREP_MPI_REGION__MPI_IEXSCAN = 206
    integer, parameter :: SCOREP_MPI_REGION__MPI_IGATHER = 207
    integer, parameter :: SCOREP_MPI_REGION__MPI_IGATHERV = 208
    integer, parameter :: SCOREP_MPI_REGION__MPI_IMPROBE = 209
    integer, parameter :: SCOREP_MPI_REGION__MPI_IMRECV = 210
    integer, parameter :: SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLGATHER = 211
    integer, parameter :: SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLGATHERV = 212
    integer, parameter :: SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALL = 213
    integer, parameter :: SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALLV = 214
    integer, parameter :: SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALLW = 215
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_C2F = 216
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_CREATE = 217
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_CREATE_ENV = 218
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_DELETE = 219
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_DUP = 220
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_F2C = 221
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_FREE = 222
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_GET = 223
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_GET_NKEYS = 224
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_GET_NTHKEY = 225
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_GET_STRING = 226
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_GET_VALUELEN = 227
    integer, parameter :: SCOREP_MPI_REGION__MPI_INFO_SET = 228
    integer, parameter :: SCOREP_MPI_REGION__MPI_INIT = 229
    integer, parameter :: SCOREP_MPI_REGION__MPI_INIT_THREAD = 230
    integer, parameter :: SCOREP_MPI_REGION__MPI_INITIALIZED = 231
    integer, parameter :: SCOREP_MPI_REGION__MPI_INTERCOMM_CREATE = 232
    integer, parameter :: SCOREP_MPI_REGION__MPI_INTERCOMM_CREATE_FROM_GROUPS = 233
    integer, parameter :: SCOREP_MPI_REGION__MPI_INTERCOMM_MERGE = 234
    integer, parameter :: SCOREP_MPI_REGION__MPI_IPROBE = 235
    integer, parameter :: SCOREP_MPI_REGION__MPI_IRECV = 236
    integer, parameter :: SCOREP_MPI_REGION__MPI_IREDUCE = 237
    integer, parameter :: SCOREP_MPI_REGION__MPI_IREDUCE_SCATTER = 238
    integer, parameter :: SCOREP_MPI_REGION__MPI_IREDUCE_SCATTER_BLOCK = 239
    integer, parameter :: SCOREP_MPI_REGION__MPI_IRSEND = 240
    integer, parameter :: SCOREP_MPI_REGION__MPI_IS_THREAD_MAIN = 241
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISCAN = 242
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISCATTER = 243
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISCATTERV = 244
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISEND = 245
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISENDRECV = 246
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISENDRECV_REPLACE = 247
    integer, parameter :: SCOREP_MPI_REGION__MPI_ISSEND = 248
    integer, parameter :: SCOREP_MPI_REGION__MPI_KEYVAL_CREATE = 249
    integer, parameter :: SCOREP_MPI_REGION__MPI_KEYVAL_FREE = 250
    integer, parameter :: SCOREP_MPI_REGION__MPI_LOOKUP_NAME = 251
    integer, parameter :: SCOREP_MPI_REGION__MPI_MESSAGE_C2F = 252
    integer, parameter :: SCOREP_MPI_REGION__MPI_MESSAGE_F2C = 253
    integer, parameter :: SCOREP_MPI_REGION__MPI_MPROBE = 254
    integer, parameter :: SCOREP_MPI_REGION__MPI_MRECV = 255
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHER = 256
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHER_INIT = 257
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHERV = 258
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHERV_INIT = 259
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALL = 260
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALL_INIT = 261
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLV = 262
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLV_INIT = 263
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLW = 264
    integer, parameter :: SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLW_INIT = 265
    integer, parameter :: SCOREP_MPI_REGION__MPI_OP_C2F = 266
    integer, parameter :: SCOREP_MPI_REGION__MPI_OP_COMMUTATIVE = 267
    integer, parameter :: SCOREP_MPI_REGION__MPI_OP_CREATE = 268
    integer, parameter :: SCOREP_MPI_REGION__MPI_OP_F2C = 269
    integer, parameter :: SCOREP_MPI_REGION__MPI_OP_FREE = 270
    integer, parameter :: SCOREP_MPI_REGION__MPI_OPEN_PORT = 271
    integer, parameter :: SCOREP_MPI_REGION__MPI_PACK = 272
    integer, parameter :: SCOREP_MPI_REGION__MPI_PACK_EXTERNAL = 273
    integer, parameter :: SCOREP_MPI_REGION__MPI_PACK_EXTERNAL_SIZE = 274
    integer, parameter :: SCOREP_MPI_REGION__MPI_PACK_SIZE = 275
    integer, parameter :: SCOREP_MPI_REGION__MPI_PARRIVED = 276
    integer, parameter :: SCOREP_MPI_REGION__MPI_PREADY = 277
    integer, parameter :: SCOREP_MPI_REGION__MPI_PREADY_LIST = 278
    integer, parameter :: SCOREP_MPI_REGION__MPI_PREADY_RANGE = 279
    integer, parameter :: SCOREP_MPI_REGION__MPI_PRECV_INIT = 280
    integer, parameter :: SCOREP_MPI_REGION__MPI_PROBE = 281
    integer, parameter :: SCOREP_MPI_REGION__MPI_PSEND_INIT = 282
    integer, parameter :: SCOREP_MPI_REGION__MPI_PUBLISH_NAME = 283
    integer, parameter :: SCOREP_MPI_REGION__MPI_PUT = 284
    integer, parameter :: SCOREP_MPI_REGION__MPI_QUERY_THREAD = 285
    integer, parameter :: SCOREP_MPI_REGION__MPI_RACCUMULATE = 286
    integer, parameter :: SCOREP_MPI_REGION__MPI_RECV = 287
    integer, parameter :: SCOREP_MPI_REGION__MPI_RECV_INIT = 288
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE = 289
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_INIT = 290
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_LOCAL = 291
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_SCATTER = 292
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_BLOCK = 293
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_BLOCK_INIT = 294
    integer, parameter :: SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_INIT = 295
    integer, parameter :: SCOREP_MPI_REGION__MPI_REGISTER_DATAREP = 296
    integer, parameter :: SCOREP_MPI_REGION__MPI_REQUEST_C2F = 297
    integer, parameter :: SCOREP_MPI_REGION__MPI_REQUEST_F2C = 298
    integer, parameter :: SCOREP_MPI_REGION__MPI_REQUEST_FREE = 299
    integer, parameter :: SCOREP_MPI_REGION__MPI_REQUEST_GET_STATUS = 300
    integer, parameter :: SCOREP_MPI_REGION__MPI_RGET = 301
    integer, parameter :: SCOREP_MPI_REGION__MPI_RGET_ACCUMULATE = 302
    integer, parameter :: SCOREP_MPI_REGION__MPI_RPUT = 303
    integer, parameter :: SCOREP_MPI_REGION__MPI_RSEND = 304
    integer, parameter :: SCOREP_MPI_REGION__MPI_RSEND_INIT = 305
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCAN = 306
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCAN_INIT = 307
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCATTER = 308
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCATTER_INIT = 309
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCATTERV = 310
    integer, parameter :: SCOREP_MPI_REGION__MPI_SCATTERV_INIT = 311
    integer, parameter :: SCOREP_MPI_REGION__MPI_SEND = 312
    integer, parameter :: SCOREP_MPI_REGION__MPI_SEND_INIT = 313
    integer, parameter :: SCOREP_MPI_REGION__MPI_SENDRECV = 314
    integer, parameter :: SCOREP_MPI_REGION__MPI_SENDRECV_REPLACE = 315
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_C2F = 316
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_CALL_ERRHANDLER = 317
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_CREATE_ERRHANDLER = 318
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_F2C = 319
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_FINALIZE = 320
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_GET_ERRHANDLER = 321
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_GET_INFO = 322
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_GET_NTH_PSET = 323
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_GET_NUM_PSETS = 324
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_GET_PSET_INFO = 325
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_INIT = 326
    integer, parameter :: SCOREP_MPI_REGION__MPI_SESSION_SET_ERRHANDLER = 327
    integer, parameter :: SCOREP_MPI_REGION__MPI_SIZEOF = 328
    integer, parameter :: SCOREP_MPI_REGION__MPI_SSEND = 329
    integer, parameter :: SCOREP_MPI_REGION__MPI_SSEND_INIT = 330
    integer, parameter :: SCOREP_MPI_REGION__MPI_START = 331
    integer, parameter :: SCOREP_MPI_REGION__MPI_STARTALL = 332
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_C2F = 333
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_C2F08 = 334
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_F082C = 335
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_F082F = 336
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_F2C = 337
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_F2F08 = 338
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_SET_CANCELLED = 339
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_SET_ELEMENTS = 340
    integer, parameter :: SCOREP_MPI_REGION__MPI_STATUS_SET_ELEMENTS_X = 341
    integer, parameter :: SCOREP_MPI_REGION__MPI_TEST = 342
    integer, parameter :: SCOREP_MPI_REGION__MPI_TEST_CANCELLED = 343
    integer, parameter :: SCOREP_MPI_REGION__MPI_TESTALL = 344
    integer, parameter :: SCOREP_MPI_REGION__MPI_TESTANY = 345
    integer, parameter :: SCOREP_MPI_REGION__MPI_TESTSOME = 346
    integer, parameter :: SCOREP_MPI_REGION__MPI_TOPO_TEST = 347
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_C2F = 348
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_COMMIT = 349
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CONTIGUOUS = 350
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_DARRAY = 351
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_COMPLEX = 352
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_INTEGER = 353
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_REAL = 354
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_HINDEXED = 355
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_HINDEXED_BLOCK = 356
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_HVECTOR = 357
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_INDEXED_BLOCK = 358
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_KEYVAL = 359
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_RESIZED = 360
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_STRUCT = 361
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_CREATE_SUBARRAY = 362
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_DELETE_ATTR = 363
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_DUP = 364
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_EXTENT = 365
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_F2C = 366
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_FREE = 367
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_FREE_KEYVAL = 368
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_ATTR = 369
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_CONTENTS = 370
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_ENVELOPE = 371
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_EXTENT = 372
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_EXTENT_X = 373
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_NAME = 374
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_TRUE_EXTENT = 375
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_GET_TRUE_EXTENT_X = 376
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_HINDEXED = 377
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_HVECTOR = 378
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_INDEXED = 379
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_LB = 380
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_MATCH_SIZE = 381
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_SET_ATTR = 382
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_SET_NAME = 383
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_SIZE = 384
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_SIZE_X = 385
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_STRUCT = 386
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_UB = 387
    integer, parameter :: SCOREP_MPI_REGION__MPI_TYPE_VECTOR = 388
    integer, parameter :: SCOREP_MPI_REGION__MPI_UNPACK = 389
    integer, parameter :: SCOREP_MPI_REGION__MPI_UNPACK_EXTERNAL = 390
    integer, parameter :: SCOREP_MPI_REGION__MPI_UNPUBLISH_NAME = 391
    integer, parameter :: SCOREP_MPI_REGION__MPI_WAIT = 392
    integer, parameter :: SCOREP_MPI_REGION__MPI_WAITALL = 393
    integer, parameter :: SCOREP_MPI_REGION__MPI_WAITANY = 394
    integer, parameter :: SCOREP_MPI_REGION__MPI_WAITSOME = 395
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_ALLOCATE = 396
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_ALLOCATE_SHARED = 397
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_ATTACH = 398
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_C2F = 399
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_CALL_ERRHANDLER = 400
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_COMPLETE = 401
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_CREATE = 402
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_CREATE_DYNAMIC = 403
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_CREATE_ERRHANDLER = 404
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_CREATE_KEYVAL = 405
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_DELETE_ATTR = 406
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_DETACH = 407
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_F2C = 408
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FENCE = 409
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FLUSH = 410
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FLUSH_ALL = 411
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FLUSH_LOCAL = 412
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FLUSH_LOCAL_ALL = 413
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FREE = 414
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_FREE_KEYVAL = 415
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_GET_ATTR = 416
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_GET_ERRHANDLER = 417
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_GET_GROUP = 418
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_GET_INFO = 419
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_GET_NAME = 420
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_LOCK = 421
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_LOCK_ALL = 422
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_POST = 423
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SET_ATTR = 424
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SET_ERRHANDLER = 425
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SET_INFO = 426
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SET_NAME = 427
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SHARED_QUERY = 428
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_START = 429
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_SYNC = 430
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_TEST = 431
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_UNLOCK = 432
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_UNLOCK_ALL = 433
    integer, parameter :: SCOREP_MPI_REGION__MPI_WIN_WAIT = 434

    integer, parameter :: SCOREP_MPI_NUM_REGIONS = 434

    integer(SCOREP_RegionHandle), bind(c, name="scorep_mpi_regions") :: scorep_mpi_regions(SCOREP_MPI_NUM_REGIONS)
end module
