/*
 * This file is part of the Score-P software (http://www.score-p.org)
 *
 * Copyright (c) 2009-2013,
 * RWTH Aachen University, Germany
 *
 * Copyright (c) 2009-2013,
 * Gesellschaft fuer numerische Simulation mbH Braunschweig, Germany
 *
 * Copyright (c) 2009-2017,
 * Technische Universitaet Dresden, Germany
 *
 * Copyright (c) 2009-2013,
 * University of Oregon, Eugene, USA
 *
 * Copyright (c) 2009-2019, 2023, 2025,
 * Forschungszentrum Juelich GmbH, Germany
 *
 * Copyright (c) 2009-2014,
 * German Research School for Simulation Sciences GmbH, Juelich/Aachen, Germany
 *
 * Copyright (c) 2009-2013,
 * Technische Universitaet Muenchen, Germany
 *
 * Copyright (c) 2016,
 * Technische Universitaet Darmstadt, Germany
 *
 * Copyright (c) 2022,
 * Deutsches Zentrum fuer Luft- und Raumfahrt, Germany
 *
 * This software may be modified and distributed under the terms of
 * a BSD-style license. See the COPYING file in the package base
 * directory for details.
 *
 */

/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2011                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2010-2011                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  Copyright (c) 2003-2008                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/*
 * This file was generated by mpi_wrapgen2 from template adapter/include/SCOREP_Mpi_Reg.h.tmpl.
 */

#ifndef SCOREP_MPI_REG_H
#define SCOREP_MPI_REG_H


/**
 * @file
 * @ingroup    MPI_Wrapper
 *
 * @brief Registration of MPI functions
 * For all MPI functions a region is registered at initialization time of the MPI adapter.
 * The dynamic region handle obtained from the measurement system is stored in an array
 * with a fixed index for every region.
 */


#include <scorep/SCOREP_PublicTypes.h>
/*
 * -----------------------------------------------------------------------------
 *
 *  - Registration of MPI functions
 *
 * -----------------------------------------------------------------------------
 */
enum scorep_mpi_regions
{
    SCOREP_MPI_REGION__MPI_ABORT,
    SCOREP_MPI_REGION__MPI_ACCUMULATE,
    SCOREP_MPI_REGION__MPI_ADD_ERROR_CLASS,
    SCOREP_MPI_REGION__MPI_ADD_ERROR_CODE,
    SCOREP_MPI_REGION__MPI_ADD_ERROR_STRING,
    SCOREP_MPI_REGION__MPI_ADDRESS,
    SCOREP_MPI_REGION__MPI_ALLGATHER,
    SCOREP_MPI_REGION__MPI_ALLGATHER_INIT,
    SCOREP_MPI_REGION__MPI_ALLGATHERV,
    SCOREP_MPI_REGION__MPI_ALLGATHERV_INIT,
    SCOREP_MPI_REGION__MPI_ALLOC_MEM,
    SCOREP_MPI_REGION__MPI_ALLREDUCE,
    SCOREP_MPI_REGION__MPI_ALLREDUCE_INIT,
    SCOREP_MPI_REGION__MPI_ALLTOALL,
    SCOREP_MPI_REGION__MPI_ALLTOALL_INIT,
    SCOREP_MPI_REGION__MPI_ALLTOALLV,
    SCOREP_MPI_REGION__MPI_ALLTOALLV_INIT,
    SCOREP_MPI_REGION__MPI_ALLTOALLW,
    SCOREP_MPI_REGION__MPI_ALLTOALLW_INIT,
    SCOREP_MPI_REGION__MPI_ATTR_DELETE,
    SCOREP_MPI_REGION__MPI_ATTR_GET,
    SCOREP_MPI_REGION__MPI_ATTR_PUT,
    SCOREP_MPI_REGION__MPI_BARRIER,
    SCOREP_MPI_REGION__MPI_BARRIER_INIT,
    SCOREP_MPI_REGION__MPI_BCAST,
    SCOREP_MPI_REGION__MPI_BCAST_INIT,
    SCOREP_MPI_REGION__MPI_BSEND,
    SCOREP_MPI_REGION__MPI_BSEND_INIT,
    SCOREP_MPI_REGION__MPI_BUFFER_ATTACH,
    SCOREP_MPI_REGION__MPI_BUFFER_DETACH,
    SCOREP_MPI_REGION__MPI_CANCEL,
    SCOREP_MPI_REGION__MPI_CART_COORDS,
    SCOREP_MPI_REGION__MPI_CART_CREATE,
    SCOREP_MPI_REGION__MPI_CART_GET,
    SCOREP_MPI_REGION__MPI_CART_MAP,
    SCOREP_MPI_REGION__MPI_CART_RANK,
    SCOREP_MPI_REGION__MPI_CART_SHIFT,
    SCOREP_MPI_REGION__MPI_CART_SUB,
    SCOREP_MPI_REGION__MPI_CARTDIM_GET,
    SCOREP_MPI_REGION__MPI_CLOSE_PORT,
    SCOREP_MPI_REGION__MPI_COMM_ACCEPT,
    SCOREP_MPI_REGION__MPI_COMM_C2F,
    SCOREP_MPI_REGION__MPI_COMM_CALL_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_COMM_COMPARE,
    SCOREP_MPI_REGION__MPI_COMM_CONNECT,
    SCOREP_MPI_REGION__MPI_COMM_CREATE,
    SCOREP_MPI_REGION__MPI_COMM_CREATE_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_COMM_CREATE_FROM_GROUP,
    SCOREP_MPI_REGION__MPI_COMM_CREATE_GROUP,
    SCOREP_MPI_REGION__MPI_COMM_CREATE_KEYVAL,
    SCOREP_MPI_REGION__MPI_COMM_DELETE_ATTR,
    SCOREP_MPI_REGION__MPI_COMM_DISCONNECT,
    SCOREP_MPI_REGION__MPI_COMM_DUP,
    SCOREP_MPI_REGION__MPI_COMM_DUP_WITH_INFO,
    SCOREP_MPI_REGION__MPI_COMM_F2C,
    SCOREP_MPI_REGION__MPI_COMM_FREE,
    SCOREP_MPI_REGION__MPI_COMM_FREE_KEYVAL,
    SCOREP_MPI_REGION__MPI_COMM_GET_ATTR,
    SCOREP_MPI_REGION__MPI_COMM_GET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_COMM_GET_INFO,
    SCOREP_MPI_REGION__MPI_COMM_GET_NAME,
    SCOREP_MPI_REGION__MPI_COMM_GET_PARENT,
    SCOREP_MPI_REGION__MPI_COMM_GROUP,
    SCOREP_MPI_REGION__MPI_COMM_IDUP,
    SCOREP_MPI_REGION__MPI_COMM_IDUP_WITH_INFO,
    SCOREP_MPI_REGION__MPI_COMM_JOIN,
    SCOREP_MPI_REGION__MPI_COMM_RANK,
    SCOREP_MPI_REGION__MPI_COMM_REMOTE_GROUP,
    SCOREP_MPI_REGION__MPI_COMM_REMOTE_SIZE,
    SCOREP_MPI_REGION__MPI_COMM_SET_ATTR,
    SCOREP_MPI_REGION__MPI_COMM_SET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_COMM_SET_INFO,
    SCOREP_MPI_REGION__MPI_COMM_SET_NAME,
    SCOREP_MPI_REGION__MPI_COMM_SIZE,
    SCOREP_MPI_REGION__MPI_COMM_SPAWN,
    SCOREP_MPI_REGION__MPI_COMM_SPAWN_MULTIPLE,
    SCOREP_MPI_REGION__MPI_COMM_SPLIT,
    SCOREP_MPI_REGION__MPI_COMM_SPLIT_TYPE,
    SCOREP_MPI_REGION__MPI_COMM_TEST_INTER,
    SCOREP_MPI_REGION__MPI_COMPARE_AND_SWAP,
    SCOREP_MPI_REGION__MPI_DIMS_CREATE,
    SCOREP_MPI_REGION__MPI_DIST_GRAPH_CREATE,
    SCOREP_MPI_REGION__MPI_DIST_GRAPH_CREATE_ADJACENT,
    SCOREP_MPI_REGION__MPI_DIST_GRAPH_NEIGHBORS,
    SCOREP_MPI_REGION__MPI_DIST_GRAPH_NEIGHBORS_COUNT,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_C2F,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_CREATE,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_F2C,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_FREE,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_GET,
    SCOREP_MPI_REGION__MPI_ERRHANDLER_SET,
    SCOREP_MPI_REGION__MPI_ERROR_CLASS,
    SCOREP_MPI_REGION__MPI_ERROR_STRING,
    SCOREP_MPI_REGION__MPI_EXSCAN,
    SCOREP_MPI_REGION__MPI_EXSCAN_INIT,
    SCOREP_MPI_REGION__MPI_FETCH_AND_OP,
    SCOREP_MPI_REGION__MPI_FILE_C2F,
    SCOREP_MPI_REGION__MPI_FILE_CALL_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_FILE_CLOSE,
    SCOREP_MPI_REGION__MPI_FILE_CREATE_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_FILE_DELETE,
    SCOREP_MPI_REGION__MPI_FILE_F2C,
    SCOREP_MPI_REGION__MPI_FILE_GET_AMODE,
    SCOREP_MPI_REGION__MPI_FILE_GET_ATOMICITY,
    SCOREP_MPI_REGION__MPI_FILE_GET_BYTE_OFFSET,
    SCOREP_MPI_REGION__MPI_FILE_GET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_FILE_GET_GROUP,
    SCOREP_MPI_REGION__MPI_FILE_GET_INFO,
    SCOREP_MPI_REGION__MPI_FILE_GET_POSITION,
    SCOREP_MPI_REGION__MPI_FILE_GET_POSITION_SHARED,
    SCOREP_MPI_REGION__MPI_FILE_GET_SIZE,
    SCOREP_MPI_REGION__MPI_FILE_GET_TYPE_EXTENT,
    SCOREP_MPI_REGION__MPI_FILE_GET_VIEW,
    SCOREP_MPI_REGION__MPI_FILE_IREAD,
    SCOREP_MPI_REGION__MPI_FILE_IREAD_ALL,
    SCOREP_MPI_REGION__MPI_FILE_IREAD_AT,
    SCOREP_MPI_REGION__MPI_FILE_IREAD_AT_ALL,
    SCOREP_MPI_REGION__MPI_FILE_IREAD_SHARED,
    SCOREP_MPI_REGION__MPI_FILE_IWRITE,
    SCOREP_MPI_REGION__MPI_FILE_IWRITE_ALL,
    SCOREP_MPI_REGION__MPI_FILE_IWRITE_AT,
    SCOREP_MPI_REGION__MPI_FILE_IWRITE_AT_ALL,
    SCOREP_MPI_REGION__MPI_FILE_IWRITE_SHARED,
    SCOREP_MPI_REGION__MPI_FILE_OPEN,
    SCOREP_MPI_REGION__MPI_FILE_PREALLOCATE,
    SCOREP_MPI_REGION__MPI_FILE_READ,
    SCOREP_MPI_REGION__MPI_FILE_READ_ALL,
    SCOREP_MPI_REGION__MPI_FILE_READ_ALL_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_READ_ALL_END,
    SCOREP_MPI_REGION__MPI_FILE_READ_AT,
    SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL,
    SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_READ_AT_ALL_END,
    SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED,
    SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_READ_ORDERED_END,
    SCOREP_MPI_REGION__MPI_FILE_READ_SHARED,
    SCOREP_MPI_REGION__MPI_FILE_SEEK,
    SCOREP_MPI_REGION__MPI_FILE_SEEK_SHARED,
    SCOREP_MPI_REGION__MPI_FILE_SET_ATOMICITY,
    SCOREP_MPI_REGION__MPI_FILE_SET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_FILE_SET_INFO,
    SCOREP_MPI_REGION__MPI_FILE_SET_SIZE,
    SCOREP_MPI_REGION__MPI_FILE_SET_VIEW,
    SCOREP_MPI_REGION__MPI_FILE_SYNC,
    SCOREP_MPI_REGION__MPI_FILE_WRITE,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ALL_END,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_AT,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_AT_ALL_END,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED_BEGIN,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_ORDERED_END,
    SCOREP_MPI_REGION__MPI_FILE_WRITE_SHARED,
    SCOREP_MPI_REGION__MPI_FINALIZE,
    SCOREP_MPI_REGION__MPI_FINALIZED,
    SCOREP_MPI_REGION__MPI_FREE_MEM,
    SCOREP_MPI_REGION__MPI_GATHER,
    SCOREP_MPI_REGION__MPI_GATHER_INIT,
    SCOREP_MPI_REGION__MPI_GATHERV,
    SCOREP_MPI_REGION__MPI_GATHERV_INIT,
    SCOREP_MPI_REGION__MPI_GET,
    SCOREP_MPI_REGION__MPI_GET_ACCUMULATE,
    SCOREP_MPI_REGION__MPI_GET_ADDRESS,
    SCOREP_MPI_REGION__MPI_GET_COUNT,
    SCOREP_MPI_REGION__MPI_GET_ELEMENTS,
    SCOREP_MPI_REGION__MPI_GET_ELEMENTS_X,
    SCOREP_MPI_REGION__MPI_GET_LIBRARY_VERSION,
    SCOREP_MPI_REGION__MPI_GET_PROCESSOR_NAME,
    SCOREP_MPI_REGION__MPI_GET_VERSION,
    SCOREP_MPI_REGION__MPI_GRAPH_CREATE,
    SCOREP_MPI_REGION__MPI_GRAPH_GET,
    SCOREP_MPI_REGION__MPI_GRAPH_MAP,
    SCOREP_MPI_REGION__MPI_GRAPH_NEIGHBORS,
    SCOREP_MPI_REGION__MPI_GRAPH_NEIGHBORS_COUNT,
    SCOREP_MPI_REGION__MPI_GRAPHDIMS_GET,
    SCOREP_MPI_REGION__MPI_GREQUEST_COMPLETE,
    SCOREP_MPI_REGION__MPI_GREQUEST_START,
    SCOREP_MPI_REGION__MPI_GROUP_C2F,
    SCOREP_MPI_REGION__MPI_GROUP_COMPARE,
    SCOREP_MPI_REGION__MPI_GROUP_DIFFERENCE,
    SCOREP_MPI_REGION__MPI_GROUP_EXCL,
    SCOREP_MPI_REGION__MPI_GROUP_F2C,
    SCOREP_MPI_REGION__MPI_GROUP_FREE,
    SCOREP_MPI_REGION__MPI_GROUP_FROM_SESSION_PSET,
    SCOREP_MPI_REGION__MPI_GROUP_INCL,
    SCOREP_MPI_REGION__MPI_GROUP_INTERSECTION,
    SCOREP_MPI_REGION__MPI_GROUP_RANGE_EXCL,
    SCOREP_MPI_REGION__MPI_GROUP_RANGE_INCL,
    SCOREP_MPI_REGION__MPI_GROUP_RANK,
    SCOREP_MPI_REGION__MPI_GROUP_SIZE,
    SCOREP_MPI_REGION__MPI_GROUP_TRANSLATE_RANKS,
    SCOREP_MPI_REGION__MPI_GROUP_UNION,
    SCOREP_MPI_REGION__MPI_IALLGATHER,
    SCOREP_MPI_REGION__MPI_IALLGATHERV,
    SCOREP_MPI_REGION__MPI_IALLREDUCE,
    SCOREP_MPI_REGION__MPI_IALLTOALL,
    SCOREP_MPI_REGION__MPI_IALLTOALLV,
    SCOREP_MPI_REGION__MPI_IALLTOALLW,
    SCOREP_MPI_REGION__MPI_IBARRIER,
    SCOREP_MPI_REGION__MPI_IBCAST,
    SCOREP_MPI_REGION__MPI_IBSEND,
    SCOREP_MPI_REGION__MPI_IEXSCAN,
    SCOREP_MPI_REGION__MPI_IGATHER,
    SCOREP_MPI_REGION__MPI_IGATHERV,
    SCOREP_MPI_REGION__MPI_IMPROBE,
    SCOREP_MPI_REGION__MPI_IMRECV,
    SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLGATHER,
    SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLGATHERV,
    SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALL,
    SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALLV,
    SCOREP_MPI_REGION__MPI_INEIGHBOR_ALLTOALLW,
    SCOREP_MPI_REGION__MPI_INFO_C2F,
    SCOREP_MPI_REGION__MPI_INFO_CREATE,
    SCOREP_MPI_REGION__MPI_INFO_CREATE_ENV,
    SCOREP_MPI_REGION__MPI_INFO_DELETE,
    SCOREP_MPI_REGION__MPI_INFO_DUP,
    SCOREP_MPI_REGION__MPI_INFO_F2C,
    SCOREP_MPI_REGION__MPI_INFO_FREE,
    SCOREP_MPI_REGION__MPI_INFO_GET,
    SCOREP_MPI_REGION__MPI_INFO_GET_NKEYS,
    SCOREP_MPI_REGION__MPI_INFO_GET_NTHKEY,
    SCOREP_MPI_REGION__MPI_INFO_GET_STRING,
    SCOREP_MPI_REGION__MPI_INFO_GET_VALUELEN,
    SCOREP_MPI_REGION__MPI_INFO_SET,
    SCOREP_MPI_REGION__MPI_INIT,
    SCOREP_MPI_REGION__MPI_INIT_THREAD,
    SCOREP_MPI_REGION__MPI_INITIALIZED,
    SCOREP_MPI_REGION__MPI_INTERCOMM_CREATE,
    SCOREP_MPI_REGION__MPI_INTERCOMM_CREATE_FROM_GROUPS,
    SCOREP_MPI_REGION__MPI_INTERCOMM_MERGE,
    SCOREP_MPI_REGION__MPI_IPROBE,
    SCOREP_MPI_REGION__MPI_IRECV,
    SCOREP_MPI_REGION__MPI_IREDUCE,
    SCOREP_MPI_REGION__MPI_IREDUCE_SCATTER,
    SCOREP_MPI_REGION__MPI_IREDUCE_SCATTER_BLOCK,
    SCOREP_MPI_REGION__MPI_IRSEND,
    SCOREP_MPI_REGION__MPI_IS_THREAD_MAIN,
    SCOREP_MPI_REGION__MPI_ISCAN,
    SCOREP_MPI_REGION__MPI_ISCATTER,
    SCOREP_MPI_REGION__MPI_ISCATTERV,
    SCOREP_MPI_REGION__MPI_ISEND,
    SCOREP_MPI_REGION__MPI_ISENDRECV,
    SCOREP_MPI_REGION__MPI_ISENDRECV_REPLACE,
    SCOREP_MPI_REGION__MPI_ISSEND,
    SCOREP_MPI_REGION__MPI_KEYVAL_CREATE,
    SCOREP_MPI_REGION__MPI_KEYVAL_FREE,
    SCOREP_MPI_REGION__MPI_LOOKUP_NAME,
    SCOREP_MPI_REGION__MPI_MESSAGE_C2F,
    SCOREP_MPI_REGION__MPI_MESSAGE_F2C,
    SCOREP_MPI_REGION__MPI_MPROBE,
    SCOREP_MPI_REGION__MPI_MRECV,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHER,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHER_INIT,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHERV,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLGATHERV_INIT,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALL,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALL_INIT,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLV,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLV_INIT,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLW,
    SCOREP_MPI_REGION__MPI_NEIGHBOR_ALLTOALLW_INIT,
    SCOREP_MPI_REGION__MPI_OP_C2F,
    SCOREP_MPI_REGION__MPI_OP_COMMUTATIVE,
    SCOREP_MPI_REGION__MPI_OP_CREATE,
    SCOREP_MPI_REGION__MPI_OP_F2C,
    SCOREP_MPI_REGION__MPI_OP_FREE,
    SCOREP_MPI_REGION__MPI_OPEN_PORT,
    SCOREP_MPI_REGION__MPI_PACK,
    SCOREP_MPI_REGION__MPI_PACK_EXTERNAL,
    SCOREP_MPI_REGION__MPI_PACK_EXTERNAL_SIZE,
    SCOREP_MPI_REGION__MPI_PACK_SIZE,
    SCOREP_MPI_REGION__MPI_PARRIVED,
    SCOREP_MPI_REGION__MPI_PREADY,
    SCOREP_MPI_REGION__MPI_PREADY_LIST,
    SCOREP_MPI_REGION__MPI_PREADY_RANGE,
    SCOREP_MPI_REGION__MPI_PRECV_INIT,
    SCOREP_MPI_REGION__MPI_PROBE,
    SCOREP_MPI_REGION__MPI_PSEND_INIT,
    SCOREP_MPI_REGION__MPI_PUBLISH_NAME,
    SCOREP_MPI_REGION__MPI_PUT,
    SCOREP_MPI_REGION__MPI_QUERY_THREAD,
    SCOREP_MPI_REGION__MPI_RACCUMULATE,
    SCOREP_MPI_REGION__MPI_RECV,
    SCOREP_MPI_REGION__MPI_RECV_INIT,
    SCOREP_MPI_REGION__MPI_REDUCE,
    SCOREP_MPI_REGION__MPI_REDUCE_INIT,
    SCOREP_MPI_REGION__MPI_REDUCE_LOCAL,
    SCOREP_MPI_REGION__MPI_REDUCE_SCATTER,
    SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_BLOCK,
    SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_BLOCK_INIT,
    SCOREP_MPI_REGION__MPI_REDUCE_SCATTER_INIT,
    SCOREP_MPI_REGION__MPI_REGISTER_DATAREP,
    SCOREP_MPI_REGION__MPI_REQUEST_C2F,
    SCOREP_MPI_REGION__MPI_REQUEST_F2C,
    SCOREP_MPI_REGION__MPI_REQUEST_FREE,
    SCOREP_MPI_REGION__MPI_REQUEST_GET_STATUS,
    SCOREP_MPI_REGION__MPI_RGET,
    SCOREP_MPI_REGION__MPI_RGET_ACCUMULATE,
    SCOREP_MPI_REGION__MPI_RPUT,
    SCOREP_MPI_REGION__MPI_RSEND,
    SCOREP_MPI_REGION__MPI_RSEND_INIT,
    SCOREP_MPI_REGION__MPI_SCAN,
    SCOREP_MPI_REGION__MPI_SCAN_INIT,
    SCOREP_MPI_REGION__MPI_SCATTER,
    SCOREP_MPI_REGION__MPI_SCATTER_INIT,
    SCOREP_MPI_REGION__MPI_SCATTERV,
    SCOREP_MPI_REGION__MPI_SCATTERV_INIT,
    SCOREP_MPI_REGION__MPI_SEND,
    SCOREP_MPI_REGION__MPI_SEND_INIT,
    SCOREP_MPI_REGION__MPI_SENDRECV,
    SCOREP_MPI_REGION__MPI_SENDRECV_REPLACE,
    SCOREP_MPI_REGION__MPI_SESSION_C2F,
    SCOREP_MPI_REGION__MPI_SESSION_CALL_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_SESSION_CREATE_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_SESSION_F2C,
    SCOREP_MPI_REGION__MPI_SESSION_FINALIZE,
    SCOREP_MPI_REGION__MPI_SESSION_GET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_SESSION_GET_INFO,
    SCOREP_MPI_REGION__MPI_SESSION_GET_NTH_PSET,
    SCOREP_MPI_REGION__MPI_SESSION_GET_NUM_PSETS,
    SCOREP_MPI_REGION__MPI_SESSION_GET_PSET_INFO,
    SCOREP_MPI_REGION__MPI_SESSION_INIT,
    SCOREP_MPI_REGION__MPI_SESSION_SET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_SIZEOF,
    SCOREP_MPI_REGION__MPI_SSEND,
    SCOREP_MPI_REGION__MPI_SSEND_INIT,
    SCOREP_MPI_REGION__MPI_START,
    SCOREP_MPI_REGION__MPI_STARTALL,
    SCOREP_MPI_REGION__MPI_STATUS_C2F,
    SCOREP_MPI_REGION__MPI_STATUS_C2F08,
    SCOREP_MPI_REGION__MPI_STATUS_F082C,
    SCOREP_MPI_REGION__MPI_STATUS_F082F,
    SCOREP_MPI_REGION__MPI_STATUS_F2C,
    SCOREP_MPI_REGION__MPI_STATUS_F2F08,
    SCOREP_MPI_REGION__MPI_STATUS_SET_CANCELLED,
    SCOREP_MPI_REGION__MPI_STATUS_SET_ELEMENTS,
    SCOREP_MPI_REGION__MPI_STATUS_SET_ELEMENTS_X,
    SCOREP_MPI_REGION__MPI_TEST,
    SCOREP_MPI_REGION__MPI_TEST_CANCELLED,
    SCOREP_MPI_REGION__MPI_TESTALL,
    SCOREP_MPI_REGION__MPI_TESTANY,
    SCOREP_MPI_REGION__MPI_TESTSOME,
    SCOREP_MPI_REGION__MPI_TOPO_TEST,
    SCOREP_MPI_REGION__MPI_TYPE_C2F,
    SCOREP_MPI_REGION__MPI_TYPE_COMMIT,
    SCOREP_MPI_REGION__MPI_TYPE_CONTIGUOUS,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_DARRAY,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_COMPLEX,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_INTEGER,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_F90_REAL,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_HINDEXED,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_HINDEXED_BLOCK,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_HVECTOR,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_INDEXED_BLOCK,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_KEYVAL,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_RESIZED,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_STRUCT,
    SCOREP_MPI_REGION__MPI_TYPE_CREATE_SUBARRAY,
    SCOREP_MPI_REGION__MPI_TYPE_DELETE_ATTR,
    SCOREP_MPI_REGION__MPI_TYPE_DUP,
    SCOREP_MPI_REGION__MPI_TYPE_EXTENT,
    SCOREP_MPI_REGION__MPI_TYPE_F2C,
    SCOREP_MPI_REGION__MPI_TYPE_FREE,
    SCOREP_MPI_REGION__MPI_TYPE_FREE_KEYVAL,
    SCOREP_MPI_REGION__MPI_TYPE_GET_ATTR,
    SCOREP_MPI_REGION__MPI_TYPE_GET_CONTENTS,
    SCOREP_MPI_REGION__MPI_TYPE_GET_ENVELOPE,
    SCOREP_MPI_REGION__MPI_TYPE_GET_EXTENT,
    SCOREP_MPI_REGION__MPI_TYPE_GET_EXTENT_X,
    SCOREP_MPI_REGION__MPI_TYPE_GET_NAME,
    SCOREP_MPI_REGION__MPI_TYPE_GET_TRUE_EXTENT,
    SCOREP_MPI_REGION__MPI_TYPE_GET_TRUE_EXTENT_X,
    SCOREP_MPI_REGION__MPI_TYPE_HINDEXED,
    SCOREP_MPI_REGION__MPI_TYPE_HVECTOR,
    SCOREP_MPI_REGION__MPI_TYPE_INDEXED,
    SCOREP_MPI_REGION__MPI_TYPE_LB,
    SCOREP_MPI_REGION__MPI_TYPE_MATCH_SIZE,
    SCOREP_MPI_REGION__MPI_TYPE_SET_ATTR,
    SCOREP_MPI_REGION__MPI_TYPE_SET_NAME,
    SCOREP_MPI_REGION__MPI_TYPE_SIZE,
    SCOREP_MPI_REGION__MPI_TYPE_SIZE_X,
    SCOREP_MPI_REGION__MPI_TYPE_STRUCT,
    SCOREP_MPI_REGION__MPI_TYPE_UB,
    SCOREP_MPI_REGION__MPI_TYPE_VECTOR,
    SCOREP_MPI_REGION__MPI_UNPACK,
    SCOREP_MPI_REGION__MPI_UNPACK_EXTERNAL,
    SCOREP_MPI_REGION__MPI_UNPUBLISH_NAME,
    SCOREP_MPI_REGION__MPI_WAIT,
    SCOREP_MPI_REGION__MPI_WAITALL,
    SCOREP_MPI_REGION__MPI_WAITANY,
    SCOREP_MPI_REGION__MPI_WAITSOME,
    SCOREP_MPI_REGION__MPI_WIN_ALLOCATE,
    SCOREP_MPI_REGION__MPI_WIN_ALLOCATE_SHARED,
    SCOREP_MPI_REGION__MPI_WIN_ATTACH,
    SCOREP_MPI_REGION__MPI_WIN_C2F,
    SCOREP_MPI_REGION__MPI_WIN_CALL_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_WIN_COMPLETE,
    SCOREP_MPI_REGION__MPI_WIN_CREATE,
    SCOREP_MPI_REGION__MPI_WIN_CREATE_DYNAMIC,
    SCOREP_MPI_REGION__MPI_WIN_CREATE_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_WIN_CREATE_KEYVAL,
    SCOREP_MPI_REGION__MPI_WIN_DELETE_ATTR,
    SCOREP_MPI_REGION__MPI_WIN_DETACH,
    SCOREP_MPI_REGION__MPI_WIN_F2C,
    SCOREP_MPI_REGION__MPI_WIN_FENCE,
    SCOREP_MPI_REGION__MPI_WIN_FLUSH,
    SCOREP_MPI_REGION__MPI_WIN_FLUSH_ALL,
    SCOREP_MPI_REGION__MPI_WIN_FLUSH_LOCAL,
    SCOREP_MPI_REGION__MPI_WIN_FLUSH_LOCAL_ALL,
    SCOREP_MPI_REGION__MPI_WIN_FREE,
    SCOREP_MPI_REGION__MPI_WIN_FREE_KEYVAL,
    SCOREP_MPI_REGION__MPI_WIN_GET_ATTR,
    SCOREP_MPI_REGION__MPI_WIN_GET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_WIN_GET_GROUP,
    SCOREP_MPI_REGION__MPI_WIN_GET_INFO,
    SCOREP_MPI_REGION__MPI_WIN_GET_NAME,
    SCOREP_MPI_REGION__MPI_WIN_LOCK,
    SCOREP_MPI_REGION__MPI_WIN_LOCK_ALL,
    SCOREP_MPI_REGION__MPI_WIN_POST,
    SCOREP_MPI_REGION__MPI_WIN_SET_ATTR,
    SCOREP_MPI_REGION__MPI_WIN_SET_ERRHANDLER,
    SCOREP_MPI_REGION__MPI_WIN_SET_INFO,
    SCOREP_MPI_REGION__MPI_WIN_SET_NAME,
    SCOREP_MPI_REGION__MPI_WIN_SHARED_QUERY,
    SCOREP_MPI_REGION__MPI_WIN_START,
    SCOREP_MPI_REGION__MPI_WIN_SYNC,
    SCOREP_MPI_REGION__MPI_WIN_TEST,
    SCOREP_MPI_REGION__MPI_WIN_UNLOCK,
    SCOREP_MPI_REGION__MPI_WIN_UNLOCK_ALL,
    SCOREP_MPI_REGION__MPI_WIN_WAIT,

    /** Total number of regions */
    SCOREP_MPI_NUM_REGIONS
};

/** Region IDs of MPI functions */
extern SCOREP_RegionHandle scorep_mpi_regions[ SCOREP_MPI_NUM_REGIONS ];

/**
 * Register MPI functions and initialize data structures
 */
void
scorep_mpi_register_regions( void );

#endif /* SCOREP_MPI_REG_H */
